package xyz.twovb.sgm.games.impl.capturethebrick.guis;


/*
 * Created by 2vb - 5/7/2024
 */

import com.github.stefvanschie.inventoryframework.gui.type.ChestGui;
import lombok.Getter;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.games.impl.capturethebrick.CTB;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.logging.Level;

public class TeamGui {
    @Getter
    private final ChestGui gui;

    private Player target;

    public TeamGui(Player player) {
        ChestGui loadedGui = null;
        try {
            File guiFile = new File(SGM.getInstance().getDataFolder(), "guis/teampicker.xml");
            if (guiFile.exists()) {
                byte[] fileContent = Files.readAllBytes(guiFile.toPath());
                InputStream inputStream = new ByteArrayInputStream(fileContent);
                loadedGui = ChestGui.load(this, inputStream);
            } else {
                SGM.getInstance().getLogger().log(Level.WARNING, "Could not find teampicker.xml file.");
            }
        } catch (Exception e) {
            SGM.getInstance().getLogger().log(Level.SEVERE, "Error loading teampicker.xml", e);
        }
        gui = loadedGui;
        target = player;
    }

    public void globalClick(InventoryClickEvent event) {
        event.setCancelled(true);
    }

    public void pickTeam(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();
        ItemStack clickedItem = event.getCurrentItem();
        CTB game = (CTB) SGM.getInstance().getGameManager().findGame(player);
        if (clickedItem.getType().equals(Material.RED_WOOL)) {
            game.addPlayerToTeam(target, true);
            game.sendMessageToAllPlayers(target.getName() + " RED");
        } else if (clickedItem.getType().equals(Material.BLUE_WOOL)) {
            game.addPlayerToTeam(target, false);
            game.sendMessageToAllPlayers(target.getName() + " BLUE");
        }
    }
}
